package meerkat.bulletinboard;

import meerkat.protobuf.Voting;
import meerkat.rest.Constants;
import meerkat.rest.ProtobufMessageBodyReader;
import meerkat.rest.ProtobufMessageBodyWriter;
import org.junit.Test;

import javax.ws.rs.client.Client;
import javax.ws.rs.client.ClientBuilder;
import javax.ws.rs.client.WebTarget;

import static org.hamcrest.CoreMatchers.is;
import static org.hamcrest.MatcherAssert.assertThat;

/**
 * Created by talm on 10/11/15.
 */
public class HelloProtoIntegrationTest {

    private static String PROP_GETTY_URL = "gretty.httpBaseURI";
    private static String BASE_URL =  System.getProperty(PROP_GETTY_URL);
    private static String HELLO_URL = BASE_URL + "/proto";

    @Test
    public void testHello() throws Exception {
        Client client = ClientBuilder.newClient();
        client.register(ProtobufMessageBodyReader.class);
        client.register(ProtobufMessageBodyWriter.class);

        WebTarget webTarget = client.target(HELLO_URL);
        Voting.BulletinBoardMessage response = webTarget.request(Constants.MEDIATYPE_PROTOBUF).get(Voting.BulletinBoardMessage.class);

        System.out.println(response.getMsg().getData());

        assertThat(response.getMsg().getData().toStringUtf8(), is("Hello World!"));
        assertThat(response.getMsg().getTagsCount(), is(2));
        assertThat(response.getMsg().getTags(0), is("Greetings"));
        assertThat(response.getMsg().getTags(1), is("FirstPrograms"));
    }
}
